% Program which :
% a) reads wav files (from a filelist)
% b) decimates from 16 to 8 khz
% c) splits up in frames of 32 msec length and 16 msec step and applies a hamming window to geerate a frame x
% d) calculate a 256 point fft zf_per and uses first part zf = zf_per(1:129), i.e. only f=[0,0.5] is used
% e) calculates log(abs(fft(zf))) and phase(fft(zf))
% f) merge abs value and phase for all frames and save to file (filelist)

Fs_orig = 16000; Fs = 8000;
step=Fs*(16/1000);
wlen=Fs*(32/1000);
N=256; % Number of frequencies per period
N2 = N/2;
Nfrq = 1+N2; % The frequencies f = [0,1/2]


wham=hamming(wlen);

Nf_train = 3465; % number of files in training set
Nf_valid = 1154; %round(Nf_train/3); % number of files in validation set
Nfiles = Nf_train + Nf_valid; %total number of files
Nf_test = 1154; % Nf_valid; % same number of files in test set as in validation set?


% filenamelist = 'train_stem_big.list';  
% fid1 = fopen(filenamelist,'r');

SNR = [0 5 10 15]; % db i.e. 10log10(Px/Pn) = SNR => Pn = Px*(0.1^(SNR/10))
noisetypes = {'car','exhibition'};%{'AWGN','babble','restaurant','street','airport','subway'};

% Bruker en gjennomsnittlig effekt av alle TIMIT-filer til  regne ut SNR:
load('globpow.mat');

% trainnumfr = 0;
% trainfilesnfr = zeros(1,Nf_train);
% 
% %%%%%%%%%%%%%%%%% PREPROCESSING TRAINING SET %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% for filenr = 1:Nf_train
% 
%     filename = fgetl(fid1); % Read filename
%     wavname = strcat('TIMIT/train_wav/',filename,'.wav'); % Add path and .wav extension
% 
%     x16k = wavread(wavname);  % Read speech
%     x= decimate(x16k,2,61,'FIR'); % Decimate to 8 khz by using a linear phase FIR filter of order 61
% 
%     numsamp=length(x);
%     nfr=floor((numsamp-(wlen-step))/step);  % Find number of steps/frames
%     
%     for noisenumb = 1:length(noisetypes)
%         for noi = 1:length(SNR)
%             outpfile = strcat('/home/studenter/olavkm/Master/Code/training_preprosd/',filename,'.frq');
%             outpfilen = strcat('/home/studenter/olavkm/Master/Code/training_preprosd/',filename,...
%                 '_',noisetypes{noisenumb},'_SNR',num2str(SNR(noi)),'_omlsa.frq');
%             disp(outpfile)
% 
%             disp([wavname ' ' outpfilen ' SNR noisetype'])
% 
%             Pn = globsigpow*(0.1^(SNR(noi)/10)); 
%             xn_tmp = addnoise(x,noisetypes{noisenumb},Pn);
%             
%             wavwrite(xn_tmp,Fs,'noisy_input.wav')
%             omlsa('noisy_input','omlsa_output');
%             xn = wavread('omlsa_output');
% 
%             fprintf('%i \t %i \t %i \t %i \t %s \n',filenr, numsamp, nfr, SNR(noi), noisetypes{noisenumb});
%             sentla=zeros(Nfrq,nfr);  % allocating the matrix for log-abs in the frequency domain
%             sentph = zeros(Nfrq,nfr); % allocating the matrix for phase in the frequency domain
%             sentlan = sentla; 
%             sentphn = sentph;  % and the noisy versions
%             for i=1:nfr
%                 z_start=1+(i-1)*step; % First sample in frame i
%                 z_end=z_start+wlen-1;  % Last sample in frame i
%                 if(z_end > numsamp)
%                     disp([i z_end numsamp])
%                     disp('error : read past end of file')  % in case of something wrong with the sample index
%                     pause
%                 end
% 
%                 if noi==1 %only make clean version once per file
%                     z=x(z_start:z_end); % samples in frame i
%                     z=wham.*z;   % applies hamming window
%                     zf_per=fft(z,N);
%                     zf = zf_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
%                     zfla=log(abs(zf));
%                     zfph = phase(zf);
%                     sentla(:,i)=zfla;
%                     sentph(:,i) = zfph;
%                 end
% 
%                 zn=xn(z_start:z_end); % samples in frame i
%                 zn=wham.*zn;   % applies hamming window
%                 zfn_per=fft(zn,N);
%                 zfn = zfn_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
%                 zflan=log(abs(zfn));
%                 zfphn = phase(zfn);
%                 sentlan(:,i)=zflan;
%                 sentphn(:,i) = zfphn;
%             end
% 
% %             if noi==1 && noisenumb==1%only save clean version once per file
% %                 senttot = ([sentla;sentph]);  % Merging clean log-abs and phase into one array for saving on file
% %                 fid4 = fopen(outpfile,'w');
% %                     fwrite(fid4,nfr,'int32');  % first write number of frames
% %                     fwrite(fid4,senttot,'float');
% %                fclose(fid4);
% %             end
% 
%            senttotn = ([sentlan;sentphn]);  % Merging noisy log-abs and phase into one array for saving on file
%             fid5 = fopen(outpfilen,'w');
%                 fwrite(fid5,nfr,'int32');  % first write number of frames
%                 fwrite(fid5,senttotn,'float');
%            fclose(fid5);
% 
%         end
%     end
% 
% end
% 
% 
% fclose(fid1);
% 
% 
% 
% %%%%%%%%%%%%%%%%%% PREPROCESSING VALIDATION SET %%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% filenamelist = 'test_overlap_stem_big.list';  
% fid1 = fopen(filenamelist,'r');
% validnumfr = 0;
% validfilesnfr=zeros(1,Nf_valid);
% 
% for filenr = 1:Nf_valid
% 
%     filename = fgetl(fid1); % Read filename
%     wavname = strcat('TIMIT/train_wav/',filename,'.wav'); % Add path and .wav extension
% 
%     x16k = wavread(wavname);  % Read speech
%     x= decimate(x16k,2,61,'FIR'); % Decimate to 8 khz by using a linear phase FIR filter of order 61
%     
%    
% 
%     numsamp=length(x);
%     nfr=floor((numsamp-(wlen-step))/step);  % Find number of steps/frames
%     
%     for noisenumb = 1:length(noisetypes)
%         for noi = 1:length(SNR)
%             outpfile = strcat('/home/studenter/olavkm/Master/Code/validation_preprosd/',filename,'.frq');
%             outpfilen = strcat('/home/studenter/olavkm/Master/Code/validation_preprosd/',filename,...
%                 '_',noisetypes{noisenumb},'_SNR',num2str(SNR(noi)),'_omlsa.frq');
% 
%             disp([wavname ' ' outpfilen ' SNR noisetypes'])
% 
%             Pn = globsigpow*(0.1^(SNR(noi)/10));
%             
%             xn_tmp = addnoise(x,noisetypes{noisenumb},Pn);
%             
%             wavwrite(xn_tmp,Fs,'noisy_input.wav')
%             omlsa('noisy_input','omlsa_output');
%             xn = wavread('omlsa_output');
% 
%             fprintf('%i \t %i \t %i \t %i \t %s \n',filenr, numsamp, nfr, SNR(noi), noisetypes{noisenumb});
%             sentla=zeros(Nfrq,nfr);  % allocating the matrix for log-abs in the frequency domain
%             sentph = zeros(Nfrq,nfr); % allocating the matrix for phase in the frequency domain
%             sentlan = sentla; 
%             sentphn = sentph;  % and the noisy versions
%             for i=1:nfr
%                 z_start=1+(i-1)*step; % First sample in frame i
%                 z_end=z_start+wlen-1;  % Last sample in frame i
%                 if(z_end > numsamp)
%                     disp([i z_end numsamp])
%                     disp('error : read past end of file')  % in case of something wrong with the sample index
%                     pause
%                 end
% 
%                 if noi==1 %only make clean version once per file
%                     z=x(z_start:z_end); % samples in frame i
%                     z=wham.*z;   % applies hamming window
%                     zf_per=fft(z,N);
%                     zf = zf_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
%                     zfla=log(abs(zf));
%                     zfph = phase(zf);
%                     sentla(:,i)=zfla;
%                     sentph(:,i) = zfph;
%                 end
% 
%                 zn=xn(z_start:z_end); % samples in frame i
%                 zn=wham.*zn;   % applies hamming window
%                 zfn_per=fft(zn,N);
%                 zfn = zfn_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
%                 zflan=log(abs(zfn));
%                 zfphn = phase(zfn);
%                 sentlan(:,i)=zflan;
%                 sentphn(:,i) = zfphn;
%             end
% 
% %             if noi==1 && noisenumb==1 %only save clean version once per file
% %                 senttot = ([sentla;sentph]);  % Merging clean log-abs and phase into one array for saving on file
% %                 fid4 = fopen(outpfile,'w');
% %                     fwrite(fid4,nfr,'int32');  % first write number of frames
% %                     fwrite(fid4,senttot,'float');
% %                fclose(fid4);
% %             end
% 
%            senttotn = ([sentlan;sentphn]);  % Merging noisy log-abs and phase into one array for saving on file
%             fid5 = fopen(outpfilen,'w');
%                 fwrite(fid5,nfr,'int32');  % first write number of frames
%                 fwrite(fid5,senttotn,'float');
%            fclose(fid5);
% 
%         end
%     end
%     
% 
% end
% 
% 
% fclose(fid1);
% 

%%%%%%%%%%%%%%%%%%% PREPROCESSING TEST SET %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

testfilelist = 'test_separate_stem.list'; % list of filenames for testset
fid1 = fopen(testfilelist,'r');
testnumfr = 0;
testfilesnfr=zeros(1,Nf_test);

for filenr = 1:Nf_test

    filename = fgetl(fid1); % Read filename
    wavname = strcat('TIMIT/test_wav/',filename,'.wav'); % Add path and .wav extension

    x16k = wavread(wavname);  % Read speech
    x= decimate(x16k,2,61,'FIR'); % Decimate to 8 khz by using a linear phase FIR filter of order 61


    numsamp=length(x);
    nfr=floor((numsamp-(wlen-step))/step);  % Find number of steps/frames
    
    for noisenumb = 1:length(noisetypes)
        for noi = 1:length(SNR)
            outpfile = strcat('/home/studenter/olavkm/Master/Code/test_preprosd/',filename,'.frq');
            outpfilen = strcat('/home/studenter/olavkm/Master/Code/test_preprosd/',filename,...
                '_',noisetypes{noisenumb},'_SNR',num2str(SNR(noi)),'_omlsa.frq');

            disp([wavname ' ' outpfilen ' SNR noisetype'])

            Pn = globsigpow*(0.1^(SNR(noi)/10));
            
            xn_tmp = addnoise(x,noisetypes{noisenumb},Pn);
            
            wavwrite(xn_tmp,Fs,'noisy_input.wav')
            omlsa('noisy_input','omlsa_output');
            xn = wavread('omlsa_output');
            
            

            fprintf('%i \t %i \t %i \t %i \t %s \n',filenr, numsamp, nfr, SNR(noi), noisetypes{noisenumb});
            sentla=zeros(Nfrq,nfr);  % allocating the matrix for log-abs in the frequency domain
            sentph = zeros(Nfrq,nfr); % allocating the matrix for phase in the frequency domain
            sentlan = sentla; 
            sentphn = sentph;  % and the noisy versions
            for i=1:nfr

                z_start=1+(i-1)*step; % First sample in frame i
                z_end=z_start+wlen-1;  % Last sample in frame i
                if(z_end > numsamp)
                    disp([i z_end numsamp])
                    disp('error : read past end of file')  % in case of something wrong with the sample index
                    pause
                end

                if noi==1 %only make clean version once per file
                    z=x(z_start:z_end); % samples in frame i
                    z=wham.*z;   % applies hamming window
                    zf_per=fft(z,N);
                    zf = zf_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
                    zfla=log(abs(zf));
                    zfph = phase(zf);
                    sentla(:,i)=zfla;
                    sentph(:,i) = zfph;
                end

                zn=xn(z_start:z_end); % samples in frame i
                zn=wham.*zn;   % applies hamming window
                zfn_per=fft(zn,N);
                zfn = zfn_per(1:Nfrq);  % Only using frequencies f=[0,0.5]
                zflan=log(abs(zfn));
                zfphn = phase(zfn);
                sentlan(:,i)=zflan;
                sentphn(:,i) = zfphn;
            end

%             if noi==1 %only save clean version once per file
%                 senttot = ([sentla;sentph]);  % Merging clean log-abs and phase into one array for saving on file
%                 fid4 = fopen(outpfile,'w');
%                     fwrite(fid4,nfr,'int32');  % first write number of frames
%                     fwrite(fid4,senttot,'float');
%                fclose(fid4);
%             end

           senttotn = ([sentlan;sentphn]);  % Merging noisy log-abs and phase into one array for saving on file
            fid5 = fopen(outpfilen,'w');
                fwrite(fid5,nfr,'int32');  % first write number of frames
                fwrite(fid5,senttotn,'float');
           fclose(fid5);

        end
    end
end

fclose(fid1);

