#Linear regression with one variable

import theano
import numpy 
import theano.tensor as T
from theano import function
rng = numpy.random.RandomState(1234)
#rng = numpy.random

class LinearRegression(object):


    def __init__(self,rng,input,n_in,n_out,W=None,b=None):
        """
        W_values = numpy.asarray(
            rng.uniform(
                low=-4*numpy.sqrt(6. / (n_in + n_out)),
                high = 4*numpy.sqrt(6. / (n_in + n_out)),
                size = (n_in,n_out)
            ),
            dtype=theano.config.floatX
        )
        """
        if W==None:
            W_values = numpy.zeros((n_in,n_out),dtype=theano.config.floatX)
        
            self.W = theano.shared(value = W_values,name='W',borrow=True)
        else:
            self.W = W
        
        if b == None:
            self.b = theano.shared(numpy.zeros((n_out,),dtype=theano.config.floatX),name='b',borrow=True)
        else:
            self.b = b

##        self.W = theano.shared(rng.randn(),name='W',borrow=True)
##
##        self.b = theano.shared(rng.randn(),name='b',borrow=True)
        
        # make weight and bias update matrices
        
        self.y_pred = T.dot(input, self.W) + self.b
        
        self.params = [self.W, self.b]
        
    
        self.input = input

        #define L2 penalty
        self.L2 = (
            (self.W**2).sum()
            )
        
    def MSE(self, y):
        return 0.5*T.mean(T.sum((y-self.y_pred)**2,axis=1))
        #return T.mean(sqr_err)/2


def train_linreg(num_epochs = 1000, batch_size=10):

    #read data and split into lines
    datafile = open('ex1data1.txt','r')
    datas = datafile.read()
    data = datas.split('\n')
    datafile.close()

    #separate input and output data and cast to float
    indata = []
    tardata = []
    for elements in data:
        if elements:
            tmp = elements.split(',')
            indata.append(float(tmp[0]))
            tardata.append(float(tmp[1]))

    #store in numpy arrays
    inputdata = numpy.asarray([indata, indata],dtype=theano.config.floatX).transpose()
    targetdata = numpy.asarray([tardata,tardata],dtype=theano.config.floatX).transpose()
    
    data_x = theano.shared(inputdata)
    data_y = theano.shared(targetdata)

    num_batches = inputdata.shape[0] / batch_size
    print(inputdata)
    print(inputdata[0:10])
    print(inputdata[0:10].shape)

    
    # defining variables:
    x = T.matrix('x')
    y = T.matrix('t')

    ind = T.lscalar('ind')

    # initialize linear regression object:
    linreg=linearRegression(rng=rng,input=x,n_in=2,n_out=2)

    # model is h_(x) = W*x + b with scalar params

    alpha = T.dscalar('alpha')
    kappa = T.dscalar('kappa')

    # defining expressions:

    cost = linreg.MSE(y) + kappa*linreg.L2
    gradW = T.grad(cost=cost, wrt=linreg.W)
    gradb = T.grad(cost=cost, wrt=linreg.b) 

    #making the training and prediciton functions
    train = function(
        inputs=[ind,alpha,kappa],outputs = cost,
        updates = [(linreg.W,linreg.W-alpha*gradW),\
                   (linreg.b,linreg.b-alpha*gradb)],
        givens = {
            x: data_x[ind*batch_size : (ind + 1)*batch_size],
            y: data_y[ind*batch_size : (ind + 1)*batch_size]
        }
    )
    #[index*batch_size : (index + 1)*batch_size]
    predict = function([x],linreg.y_pred,name='predict')

    #theano.printing.pydotprint(train,outfile ='linreg.png',var_with_name_simple = True)



    for i in range(num_epochs):
        accloss = 0
        for batch_ind in xrange(num_batches):
            alpha = 0.01
            kappa = 0.0
            
            loss = train(batch_ind,alpha,kappa)
            accloss +=loss
        
        
        
        print('Average cost over mini-batches is ' + str(accloss/num_batches))

    print(linreg.b.get_value())
    print(linreg.W.get_value())


if __name__ == '__main__':
    train_linreg(1500,10)
