# -*- coding: utf-8 -*-
"""
Created on Mon Feb  8 12:45:37 2016

@author: Olav
"""

import numpy as np

import theano
import scipy.io
theano.config.floatX='float32'


def shuffle_in_unison_scary(a, b):
    seed = 2361
    rng = np.random.RandomState(seed)
    assert(a.shape[0]==b.shape[0])
    #rng_state = np.random.get_state()
    rng.shuffle(a)
    rng = np.random.RandomState(seed)
    #np.random.set_state(rng_state)
    rng.shuffle(b)

def load_data_2(filelist = 'train_stem_5h.list',path = 'training_preprosd/',
                Nframes = 240,left_cfr = 2,right_cfr = 2,Nfrq = 129,
                SNRlist = [0, 5, 10, 15],noisetypes = ['AWGN','babble','restaurant','street'],
                shuffle_whole = True,start_line = 0,noiseperfile = 1):
    
    """
    filelist is the list of TIMIT speech file names
    
    path is the path to the preprocessed .frq files
    
    Nfiles is the number of files to be read from filelist
    
    numb_cfr is the number of frames in the input = 1 + number of context frames
    
    Nfrq is number of frequency samples in one fram (one sided spectrum)
    
    SNRlist is the different SNR levels every file from the file list are available in
    """
    
    
    numb_cfr = left_cfr+1+right_cfr
    savestuff = {}
    # open list of filenames

        
    
    with open(filelist) as  fid1:
        filestems = fid1.read().splitlines()
    
    #allocate data-arrays   
    inputdata = np.zeros((Nframes,numb_cfr*Nfrq),
                         dtype = theano.config.floatX)
    targetdata = np.zeros((Nframes,Nfrq),
                          dtype = theano.config.floatX)
    
    
    frame_ind_total = 0 #frame index for total data matrix
    done_with_files = False
    # loop through files again, reading in data to allocated 2D arrays
    for filenr in range(start_line,start_line+10000):
        
        #what kind of noise (use two types per file)
        noisechoice = []
        for noisenumb in xrange(noiseperfile):
            noisechoice.append(noisetypes[(filenr+noisenumb)%(len(noisetypes))])
        
        frame_ind = 0 #frame index for data from single file
       
        
        ############## code for reading clean file #############
        
        # path to preprocessed clean file
        filename = path+ filestems[filenr] + '.frq'
        fid2 = open(filename,'rb')
        
        # read number of frames into numpy int
        nfr_file = np.fromfile(fid2,np.int32,count = 1)
        
        #allocate data arrays for this file
        inputfiledata = np.zeros(((noiseperfile*len(SNRlist)+1) * (nfr_file[0]-(numb_cfr-1)),numb_cfr*Nfrq),
                                 dtype = theano.config.floatX)
        targetfiledata = np.zeros(((noiseperfile*len(SNRlist)+1) * (nfr_file[0]-(numb_cfr-1)),Nfrq),
                                 dtype = theano.config.floatX)
        
        # read amplitude and phase data in float32 numbers
        frq_content = np.fromfile(fid2,np.float32,count = 2*Nfrq*nfr_file)
        
        #shape to 2D array (matrix) as it was in MATLAB
        totmat_clean = np.reshape(frq_content,(2*Nfrq,nfr_file),'F')
        
        #add frames from file to data arrays
        for k in range(nfr_file[0]-(numb_cfr-1)):
            temp = totmat_clean[0:129][:,k:k+numb_cfr].flatten('F')
            inputfiledata[frame_ind+k][:] = temp
            targetfiledata[frame_ind+k][:] = totmat_clean[0:129][:,k+left_cfr]
            
            if (frame_ind_total+frame_ind+k+1) == Nframes:
                done_with_files = True
                break #frame-loop
                
        frame_ind += k+1
        
        if done_with_files:
            break #(file)-loop
            
        fid2.close() 
        
         ############ code for reading noisy versions of file ########
        for noisetype in noisechoice: #loop over noisetypes in subset noisechoice
            for SNR in SNRlist: #repeat for every SNR

                #path to preprocessed noisy filewith current SNR 
                filename=(path+filestems[filenr]+'_'+noisetype+
                '_SNR'+str(SNR)+'.frq')
                fid2 = open(filename,'rb')

                # read number of frames into numpy int
                nfr_file = np.fromfile(fid2,np.int32,count = 1)

                # read amplitude and phase data in float32 numbers
                frq_content = np.fromfile(fid2,np.float32,count = 2*Nfrq*nfr_file)

                #shape to 2D array (matrix) as it was in MATLAB
                totmat_noisy = np.reshape(frq_content,(2*Nfrq,nfr_file),'F')

                #add frames from file to data arrays
                for k in range(nfr_file[0]-(numb_cfr-1)):
                    temp = totmat_noisy[0:129][:,k:k+numb_cfr].flatten('F')
                    inputfiledata[frame_ind+k][:] = temp
                    targetfiledata[frame_ind+k][:] = totmat_clean[0:129][:,k+left_cfr]

                    # stop adding frames when reaching number equaling 
                    # biggest integer*mini_batch_size for this file
                    if (frame_ind_total+frame_ind+k+1) == Nframes:
                        done_with_files = True
                        break #frame-loop

                frame_ind += k+1

                fid2.close()

                if done_with_files:
                    break #SNR-loop
                    
            if done_with_files:
                break #noisetype-loop
        
        
        inputdata[frame_ind_total : frame_ind_total + frame_ind][:] = inputfiledata[0:frame_ind][:]
        targetdata[frame_ind_total : frame_ind_total + frame_ind][:] = targetfiledata[0:frame_ind][:]
        
        frame_ind_total +=frame_ind
            
        if done_with_files:
            break #(file)-loop
            

    
    filenr +=1 #return number of file next in list
    if shuffle_whole: 
        shuffle_in_unison_scary(inputdata, targetdata)
        
    return inputdata,targetdata,filenr
        
        
